local TSM = select(2, ...)
local Sort = TSM:NewModule("Sort")
local Util = TSM:GetModule("Util")
TSM.CurrentPlayerGuild = GetGuildInfo("player")
Sort.BagItemsTable = {}

function Sort:GetGBankItems() --- not yet used
	local Table = {}
	for Tab = 1 , GetNumGuildBankTabs(), 1 do
		if select(5, GetGuildBankTabInfo(Tab)) > 0 or IsGuildLeader(UnitName("player")) then
			for slot = 1, MAX_GUILDBANK_SLOTS_PER_TAB or 98 do
				local Item = GetGuildBankItemLink(Tab, slot)
				if Item then
					local quantity = select(2, GetGuildBankItemInfo(Tab, slot))
					TSM:Print(baseItemString,itemString,quantity,Tab)
					Table[Item] = { }
				end
			end
		end
	end
	return Table
end

function Sort:StartGbankSort()--- not yet used
	local GbankItems = Sort:GetGBankItems()
	for i,v in pairs(GbankItems) do
		print(i,v)
	end
end

function Sort:StartGbankPut()
	if(GuildBankFrame and GuildBankFrame:IsShown()) then
		TSM:Print("Starting to move items")
		Sort:GenerateBagItems()
		TSMAPI:CreateTimeDelay("GBankPut", 0.5,Sort.GbankPutRun, 0.60)
	else
		TSM:Print("Not at guild bank")
	end
end

local IterationNumberGbankPut = 1
local GbankPutReRun = true
function Sort.GbankPutRun()

	local Table = Sort.BagItemsTable
	local TableSize = table.getn(Table)
	
	if IterationNumberGbankPut <= TableSize then		
		local Tab = Table[IterationNumberGbankPut]["Tab"]
		local BagSlotNum = Table[IterationNumberGbankPut]["BagSlotNum"]
		local Bag = Table[IterationNumberGbankPut]["Bag"]
		
		print("Tab = "..tostring(Tab).." Slot Num = "..tostring(BagSlotNum).." Bag = "..tostring(Bag))
		if Tab == nil or Bag == nil or BagSlotNum == nil then
			IterationNumberGbankPut = IterationNumberGbankPut + 1
			return
		end
		
		if GetCurrentGuildBankTab ~= Tab then
			SetCurrentGuildBankTab(Tab)
		end
		UseContainerItem(Bag, BagSlotNum)
		
		IterationNumberGbankPut = IterationNumberGbankPut + 1
	elseif GbankPutReRun == true then
		print("Re-running")
		Sort:GenerateBagItems()
		GbankPutReRun = false
	else
		print("Iteration entered cancel")
		GbankPutReRun = true
		IterationNumberGbankPut = 1
		TSM:Print("Finished moving items.")
		TSMAPI:CancelFrame("GBankPut")
	end
end



function Sort:GenerateBagItems()
	local Bags = 0
	local Guild, Tab
	local Item
	local GenerateBagItemsIterationNumber = 0
	Sort.BagItemsTable = {}
	
	for BagSlot = 1, 4, 1 do
		if GetContainerNumSlots(BagSlot) then
			Bags = Bags + 1
		end
	end
	for Bag = 1, Bags, 1 do
		local BagSlotNumbers = GetContainerNumSlots(Bag)
		
		for BagSlotNum = 1, BagSlotNumbers, 1 do
			Item = GetContainerItemID(Bag, BagSlotNum)
			Guild, Tab = Util:CheckTabAndGuild(Item)
			if Guild == nil or Tab == nil then
				
			else
				if Guild == TSM.CurrentPlayerGuild then
					GenerateBagItemsIterationNumber = GenerateBagItemsIterationNumber + 1
					Sort.BagItemsTable[GenerateBagItemsIterationNumber] = {}
					Sort.BagItemsTable[GenerateBagItemsIterationNumber]["Tab"] = Tab
					Sort.BagItemsTable[GenerateBagItemsIterationNumber]["BagSlotNum"] = BagSlotNum
					Sort.BagItemsTable[GenerateBagItemsIterationNumber]["Bag"] = Bag
				end
			end
		end
	end
	return Table
end